// TestValues class for Expr lab
 
// (c) J. Dean Brock, Rebecca F. Bruce, 2004
// Department of Computer Science
// University of North Carolina at Asheville

package edu.unca.cs.LabAids;

/**
 * A class that can generate "random" solution sets.
 * There are 100 possible solution sets numbered from 0 to 99.
 * Each solution set can consists of several integer and double values.
 * The mathematics to generate the random numbers is very simple.
 */
public class TestValues {

    int SetNum = 49 ;
    
    /**
     * Default constructor.  Solution set number is arbitrary.
     */
    public TestValues() {
    }

    /**
     * Constructor that allow specification of solution set number.
     * @param OrigSetNum Solution set number.  Should be between 0 and 99.
     */
    public TestValues(int OrigSetNum) {
        SetNum = Math.abs(OrigSetNum)%100 ;
    }
    
    /**
     * Get solution set number.
     * @return Solution set number
     */
    public int getSetNum() {
        return SetNum ;
    }
    
    /**
     * Sets solution set number.
     * @param NewSetNum New solution set number.  Should be between 0 and 99.
     */
    public void setSetNum(int NewSetNum) {
        SetNum = Math.abs(NewSetNum)%100 ;
    }
    
    /**
     * Gets i'th integer value of the solution set.
     * @return i'th value of the solution set.  This will be a number between 0 and 99.
     * @param i Index into the solution set.  Should be positive.
     */
    public int getIthInteger(int i) {
        return Math.abs(SetNum + 13 + Math.abs(i)*37) % 100 ;
    }
   
    /**
     * Gets i'th double value of the solution set.
     * @return i'th value of the solution set.  This will be a number between 0.00 and 99.99
     * @param i Index into the solution set.  Should be positive.
     */
    public double getIthDouble(int i) {
        return Math.abs(SetNum + 42 + Math.abs(i)*47)%100 + Math.abs(SetNum + 3 + 19*i)/100.0 ;
    }
}
